"use strict";
var __esDecorate = (this && this.__esDecorate) || function (ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
    function accept(f) { if (f !== void 0 && typeof f !== "function") throw new TypeError("Function expected"); return f; }
    var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
    var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
    var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
    var _, done = false;
    for (var i = decorators.length - 1; i >= 0; i--) {
        var context = {};
        for (var p in contextIn) context[p] = p === "access" ? {} : contextIn[p];
        for (var p in contextIn.access) context.access[p] = contextIn.access[p];
        context.addInitializer = function (f) { if (done) throw new TypeError("Cannot add initializers after decoration has completed"); extraInitializers.push(accept(f || null)); };
        var result = (0, decorators[i])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key], context);
        if (kind === "accessor") {
            if (result === void 0) continue;
            if (result === null || typeof result !== "object") throw new TypeError("Object expected");
            if (_ = accept(result.get)) descriptor.get = _;
            if (_ = accept(result.set)) descriptor.set = _;
            if (_ = accept(result.init)) initializers.unshift(_);
        }
        else if (_ = accept(result)) {
            if (kind === "field") initializers.unshift(_);
            else descriptor[key] = _;
        }
    }
    if (target) Object.defineProperty(target, contextIn.name, descriptor);
    done = true;
};
var __runInitializers = (this && this.__runInitializers) || function (thisArg, initializers, value) {
    var useValue = arguments.length > 2;
    for (var i = 0; i < initializers.length; i++) {
        value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
    }
    return useValue ? value : void 0;
};
var __setFunctionName = (this && this.__setFunctionName) || function (f, name, prefix) {
    if (typeof name === "symbol") name = name.description ? "[".concat(name.description, "]") : "";
    return Object.defineProperty(f, "name", { configurable: true, value: prefix ? "".concat(prefix, " ", name) : name });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FormService = void 0;
const core_1 = require("@angular/core");
const forms_1 = require("@angular/forms");
let FormService = exports.FormService = (() => {
    let _classDecorators = [(0, core_1.Injectable)({
            providedIn: 'root'
        })];
    let _classDescriptor;
    let _classExtraInitializers = [];
    let _classThis;
    var FormService = _classThis = class {
        constructor(formBuilder) {
            this.formBuilder = formBuilder;
        }
        createForm(model, options) {
            const formGroup = {};
            for (const field in model) {
                if (model.hasOwnProperty(field)) {
                    const fieldConfig = options && options[field] ? options[field] : {};
                    formGroup[field] = this.createControl(model[field], fieldConfig);
                }
            }
            return this.formBuilder.group(formGroup);
        }
        createControl(value, config) {
            const formControl = this.formBuilder.control({ value: value, disabled: !config.enabled }, this.normalizeValidations(config.validations), this.normalizeAsyncValidations(config.asyncValidations));
            if (config.customValidation) {
                formControl.setValidators([config.customValidation]);
            }
            if (config.asyncCustomValidation) {
                formControl.setAsyncValidators([config.asyncCustomValidation]);
            }
            if (config.requiredIf) {
                formControl.setValidators([this.conditionallyRequiredValidator(config)]);
            }
            return formControl;
        }
        conditionallyRequiredValidator(config) {
            return (control) => {
                if (this.isConditionallyRequired(config)) {
                    if (forms_1.Validators.required(control)) {
                        return null;
                    }
                    else {
                        return { required: true };
                    }
                }
                return null;
            };
        }
        isConditionallyRequired(config) {
            return config.requiredIf && config.requiredIf.condition ? config.requiredIf.condition() : false;
        }
        normalizeValidations(validations) {
            if (!validations) {
                return null;
            }
            const validatorArray = [];
            for (const key in validations) {
                if (validations.hasOwnProperty(key) && forms_1.Validators.hasOwnProperty(key)) {
                    validatorArray.push(forms_1.Validators[key](validations[key]));
                }
            }
            return validatorArray.length > 0 ? forms_1.Validators.compose(validatorArray) : null;
        }
        normalizeAsyncValidations(asyncValidations) {
            if (!asyncValidations) {
                return null;
            }
            const asyncValidatorArray = [];
            for (const key in asyncValidations) {
                if (asyncValidations.hasOwnProperty(key) && forms_1.Validators.hasOwnProperty(key)) {
                    asyncValidatorArray.push(forms_1.Validators[key](asyncValidations[key]));
                }
            }
            return asyncValidatorArray.length > 0 ? forms_1.Validators.composeAsync(asyncValidatorArray) : null;
        }
    };
    __setFunctionName(_classThis, "FormService");
    (() => {
        __esDecorate(null, _classDescriptor = { value: _classThis }, _classDecorators, { kind: "class", name: _classThis.name }, null, _classExtraInitializers);
        FormService = _classThis = _classDescriptor.value;
        __runInitializers(_classThis, _classExtraInitializers);
    })();
    return FormService = _classThis;
})();
